import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ECSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ECSClient";
import {
  DeleteTaskDefinitionsRequest,
  DeleteTaskDefinitionsResponse,
} from "../models/models_0";
export interface DeleteTaskDefinitionsCommandInput
  extends DeleteTaskDefinitionsRequest {}
export interface DeleteTaskDefinitionsCommandOutput
  extends DeleteTaskDefinitionsResponse,
    __MetadataBearer {}
export declare class DeleteTaskDefinitionsCommand extends $Command<
  DeleteTaskDefinitionsCommandInput,
  DeleteTaskDefinitionsCommandOutput,
  ECSClientResolvedConfig
> {
  readonly input: DeleteTaskDefinitionsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeleteTaskDefinitionsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ECSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeleteTaskDefinitionsCommandInput,
    DeleteTaskDefinitionsCommandOutput
  >;
  private serialize;
  private deserialize;
}
