import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ECSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ECSClient";
import {
  GetTaskProtectionRequest,
  GetTaskProtectionResponse,
} from "../models/models_0";
export interface GetTaskProtectionCommandInput
  extends GetTaskProtectionRequest {}
export interface GetTaskProtectionCommandOutput
  extends GetTaskProtectionResponse,
    __MetadataBearer {}
export declare class GetTaskProtectionCommand extends $Command<
  GetTaskProtectionCommandInput,
  GetTaskProtectionCommandOutput,
  ECSClientResolvedConfig
> {
  readonly input: GetTaskProtectionCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetTaskProtectionCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ECSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetTaskProtectionCommandInput, GetTaskProtectionCommandOutput>;
  private serialize;
  private deserialize;
}
