import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ECSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ECSClient";
import {
  UpdateTaskProtectionRequest,
  UpdateTaskProtectionResponse,
} from "../models/models_0";
export interface UpdateTaskProtectionCommandInput
  extends UpdateTaskProtectionRequest {}
export interface UpdateTaskProtectionCommandOutput
  extends UpdateTaskProtectionResponse,
    __MetadataBearer {}
export declare class UpdateTaskProtectionCommand extends $Command<
  UpdateTaskProtectionCommandInput,
  UpdateTaskProtectionCommandOutput,
  ECSClientResolvedConfig
> {
  readonly input: UpdateTaskProtectionCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateTaskProtectionCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ECSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateTaskProtectionCommandInput,
    UpdateTaskProtectionCommandOutput
  >;
  private serialize;
  private deserialize;
}
