import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { EventStreamSerdeContext as __EventStreamSerdeContext, SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { AddTagsToStreamCommandInput, AddTagsToStreamCommandOutput } from "../commands/AddTagsToStreamCommand";
import { CreateStreamCommandInput, CreateStreamCommandOutput } from "../commands/CreateStreamCommand";
import { DecreaseStreamRetentionPeriodCommandInput, DecreaseStreamRetentionPeriodCommandOutput } from "../commands/DecreaseStreamRetentionPeriodCommand";
import { DeleteStreamCommandInput, DeleteStreamCommandOutput } from "../commands/DeleteStreamCommand";
import { DeregisterStreamConsumerCommandInput, DeregisterStreamConsumerCommandOutput } from "../commands/DeregisterStreamConsumerCommand";
import { DescribeLimitsCommandInput, DescribeLimitsCommandOutput } from "../commands/DescribeLimitsCommand";
import { DescribeStreamCommandInput, DescribeStreamCommandOutput } from "../commands/DescribeStreamCommand";
import { DescribeStreamConsumerCommandInput, DescribeStreamConsumerCommandOutput } from "../commands/DescribeStreamConsumerCommand";
import { DescribeStreamSummaryCommandInput, DescribeStreamSummaryCommandOutput } from "../commands/DescribeStreamSummaryCommand";
import { DisableEnhancedMonitoringCommandInput, DisableEnhancedMonitoringCommandOutput } from "../commands/DisableEnhancedMonitoringCommand";
import { EnableEnhancedMonitoringCommandInput, EnableEnhancedMonitoringCommandOutput } from "../commands/EnableEnhancedMonitoringCommand";
import { GetRecordsCommandInput, GetRecordsCommandOutput } from "../commands/GetRecordsCommand";
import { GetShardIteratorCommandInput, GetShardIteratorCommandOutput } from "../commands/GetShardIteratorCommand";
import { IncreaseStreamRetentionPeriodCommandInput, IncreaseStreamRetentionPeriodCommandOutput } from "../commands/IncreaseStreamRetentionPeriodCommand";
import { ListShardsCommandInput, ListShardsCommandOutput } from "../commands/ListShardsCommand";
import { ListStreamConsumersCommandInput, ListStreamConsumersCommandOutput } from "../commands/ListStreamConsumersCommand";
import { ListStreamsCommandInput, ListStreamsCommandOutput } from "../commands/ListStreamsCommand";
import { ListTagsForStreamCommandInput, ListTagsForStreamCommandOutput } from "../commands/ListTagsForStreamCommand";
import { MergeShardsCommandInput, MergeShardsCommandOutput } from "../commands/MergeShardsCommand";
import { PutRecordCommandInput, PutRecordCommandOutput } from "../commands/PutRecordCommand";
import { PutRecordsCommandInput, PutRecordsCommandOutput } from "../commands/PutRecordsCommand";
import { RegisterStreamConsumerCommandInput, RegisterStreamConsumerCommandOutput } from "../commands/RegisterStreamConsumerCommand";
import { RemoveTagsFromStreamCommandInput, RemoveTagsFromStreamCommandOutput } from "../commands/RemoveTagsFromStreamCommand";
import { SplitShardCommandInput, SplitShardCommandOutput } from "../commands/SplitShardCommand";
import { StartStreamEncryptionCommandInput, StartStreamEncryptionCommandOutput } from "../commands/StartStreamEncryptionCommand";
import { StopStreamEncryptionCommandInput, StopStreamEncryptionCommandOutput } from "../commands/StopStreamEncryptionCommand";
import { SubscribeToShardCommandInput, SubscribeToShardCommandOutput } from "../commands/SubscribeToShardCommand";
import { UpdateShardCountCommandInput, UpdateShardCountCommandOutput } from "../commands/UpdateShardCountCommand";
import { UpdateStreamModeCommandInput, UpdateStreamModeCommandOutput } from "../commands/UpdateStreamModeCommand";
export declare const serializeAws_json1_1AddTagsToStreamCommand: (input: AddTagsToStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1CreateStreamCommand: (input: CreateStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DecreaseStreamRetentionPeriodCommand: (input: DecreaseStreamRetentionPeriodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteStreamCommand: (input: DeleteStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeregisterStreamConsumerCommand: (input: DeregisterStreamConsumerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DescribeLimitsCommand: (input: DescribeLimitsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DescribeStreamCommand: (input: DescribeStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DescribeStreamConsumerCommand: (input: DescribeStreamConsumerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DescribeStreamSummaryCommand: (input: DescribeStreamSummaryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DisableEnhancedMonitoringCommand: (input: DisableEnhancedMonitoringCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1EnableEnhancedMonitoringCommand: (input: EnableEnhancedMonitoringCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetRecordsCommand: (input: GetRecordsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetShardIteratorCommand: (input: GetShardIteratorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1IncreaseStreamRetentionPeriodCommand: (input: IncreaseStreamRetentionPeriodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListShardsCommand: (input: ListShardsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListStreamConsumersCommand: (input: ListStreamConsumersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListStreamsCommand: (input: ListStreamsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListTagsForStreamCommand: (input: ListTagsForStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1MergeShardsCommand: (input: MergeShardsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutRecordCommand: (input: PutRecordCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutRecordsCommand: (input: PutRecordsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RegisterStreamConsumerCommand: (input: RegisterStreamConsumerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RemoveTagsFromStreamCommand: (input: RemoveTagsFromStreamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1SplitShardCommand: (input: SplitShardCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StartStreamEncryptionCommand: (input: StartStreamEncryptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StopStreamEncryptionCommand: (input: StopStreamEncryptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1SubscribeToShardCommand: (input: SubscribeToShardCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateShardCountCommand: (input: UpdateShardCountCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateStreamModeCommand: (input: UpdateStreamModeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_json1_1AddTagsToStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AddTagsToStreamCommandOutput>;
export declare const deserializeAws_json1_1CreateStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateStreamCommandOutput>;
export declare const deserializeAws_json1_1DecreaseStreamRetentionPeriodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DecreaseStreamRetentionPeriodCommandOutput>;
export declare const deserializeAws_json1_1DeleteStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteStreamCommandOutput>;
export declare const deserializeAws_json1_1DeregisterStreamConsumerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterStreamConsumerCommandOutput>;
export declare const deserializeAws_json1_1DescribeLimitsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLimitsCommandOutput>;
export declare const deserializeAws_json1_1DescribeStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStreamCommandOutput>;
export declare const deserializeAws_json1_1DescribeStreamConsumerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStreamConsumerCommandOutput>;
export declare const deserializeAws_json1_1DescribeStreamSummaryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStreamSummaryCommandOutput>;
export declare const deserializeAws_json1_1DisableEnhancedMonitoringCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableEnhancedMonitoringCommandOutput>;
export declare const deserializeAws_json1_1EnableEnhancedMonitoringCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableEnhancedMonitoringCommandOutput>;
export declare const deserializeAws_json1_1GetRecordsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRecordsCommandOutput>;
export declare const deserializeAws_json1_1GetShardIteratorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetShardIteratorCommandOutput>;
export declare const deserializeAws_json1_1IncreaseStreamRetentionPeriodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<IncreaseStreamRetentionPeriodCommandOutput>;
export declare const deserializeAws_json1_1ListShardsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListShardsCommandOutput>;
export declare const deserializeAws_json1_1ListStreamConsumersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListStreamConsumersCommandOutput>;
export declare const deserializeAws_json1_1ListStreamsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListStreamsCommandOutput>;
export declare const deserializeAws_json1_1ListTagsForStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForStreamCommandOutput>;
export declare const deserializeAws_json1_1MergeShardsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MergeShardsCommandOutput>;
export declare const deserializeAws_json1_1PutRecordCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRecordCommandOutput>;
export declare const deserializeAws_json1_1PutRecordsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRecordsCommandOutput>;
export declare const deserializeAws_json1_1RegisterStreamConsumerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterStreamConsumerCommandOutput>;
export declare const deserializeAws_json1_1RemoveTagsFromStreamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RemoveTagsFromStreamCommandOutput>;
export declare const deserializeAws_json1_1SplitShardCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SplitShardCommandOutput>;
export declare const deserializeAws_json1_1StartStreamEncryptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartStreamEncryptionCommandOutput>;
export declare const deserializeAws_json1_1StopStreamEncryptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopStreamEncryptionCommandOutput>;
export declare const deserializeAws_json1_1SubscribeToShardCommand: (output: __HttpResponse, context: __SerdeContext & __EventStreamSerdeContext) => Promise<SubscribeToShardCommandOutput>;
export declare const deserializeAws_json1_1UpdateShardCountCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateShardCountCommandOutput>;
export declare const deserializeAws_json1_1UpdateStreamModeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateStreamModeCommandOutput>;
