"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarketplaceMetering = void 0;
const BatchMeterUsageCommand_1 = require("./commands/BatchMeterUsageCommand");
const MeterUsageCommand_1 = require("./commands/MeterUsageCommand");
const RegisterUsageCommand_1 = require("./commands/RegisterUsageCommand");
const ResolveCustomerCommand_1 = require("./commands/ResolveCustomerCommand");
const MarketplaceMeteringClient_1 = require("./MarketplaceMeteringClient");
class MarketplaceMetering extends MarketplaceMeteringClient_1.MarketplaceMeteringClient {
    batchMeterUsage(args, optionsOrCb, cb) {
        const command = new BatchMeterUsageCommand_1.BatchMeterUsageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    meterUsage(args, optionsOrCb, cb) {
        const command = new MeterUsageCommand_1.MeterUsageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    registerUsage(args, optionsOrCb, cb) {
        const command = new RegisterUsageCommand_1.RegisterUsageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    resolveCustomer(args, optionsOrCb, cb) {
        const command = new ResolveCustomerCommand_1.ResolveCustomerCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
}
exports.MarketplaceMetering = MarketplaceMetering;
