"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResolveCustomerResultFilterSensitiveLog = exports.ResolveCustomerRequestFilterSensitiveLog = exports.RegisterUsageResultFilterSensitiveLog = exports.RegisterUsageRequestFilterSensitiveLog = exports.MeterUsageResultFilterSensitiveLog = exports.MeterUsageRequestFilterSensitiveLog = exports.BatchMeterUsageResultFilterSensitiveLog = exports.UsageRecordResultFilterSensitiveLog = exports.BatchMeterUsageRequestFilterSensitiveLog = exports.UsageRecordFilterSensitiveLog = exports.UsageAllocationFilterSensitiveLog = exports.TagFilterSensitiveLog = exports.InvalidTokenException = exports.ExpiredTokenException = exports.PlatformNotSupportedException = exports.InvalidRegionException = exports.InvalidPublicKeyVersionException = exports.InvalidEndpointRegionException = exports.DuplicateRequestException = exports.CustomerNotEntitledException = exports.TimestampOutOfBoundsException = exports.ThrottlingException = exports.InvalidUsageDimensionException = exports.InvalidUsageAllocationsException = exports.InvalidTagException = exports.InvalidProductCodeException = exports.InvalidCustomerIdentifierException = exports.InternalServiceErrorException = exports.DisabledApiException = exports.UsageRecordResultStatus = void 0;
const MarketplaceMeteringServiceException_1 = require("./MarketplaceMeteringServiceException");
var UsageRecordResultStatus;
(function (UsageRecordResultStatus) {
    UsageRecordResultStatus["CUSTOMER_NOT_SUBSCRIBED"] = "CustomerNotSubscribed";
    UsageRecordResultStatus["DUPLICATE_RECORD"] = "DuplicateRecord";
    UsageRecordResultStatus["SUCCESS"] = "Success";
})(UsageRecordResultStatus = exports.UsageRecordResultStatus || (exports.UsageRecordResultStatus = {}));
class DisabledApiException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "DisabledApiException",
            $fault: "client",
            ...opts,
        });
        this.name = "DisabledApiException";
        this.$fault = "client";
        Object.setPrototypeOf(this, DisabledApiException.prototype);
    }
}
exports.DisabledApiException = DisabledApiException;
class InternalServiceErrorException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InternalServiceErrorException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServiceErrorException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServiceErrorException.prototype);
    }
}
exports.InternalServiceErrorException = InternalServiceErrorException;
class InvalidCustomerIdentifierException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidCustomerIdentifierException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidCustomerIdentifierException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidCustomerIdentifierException.prototype);
    }
}
exports.InvalidCustomerIdentifierException = InvalidCustomerIdentifierException;
class InvalidProductCodeException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidProductCodeException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidProductCodeException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidProductCodeException.prototype);
    }
}
exports.InvalidProductCodeException = InvalidProductCodeException;
class InvalidTagException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidTagException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidTagException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidTagException.prototype);
    }
}
exports.InvalidTagException = InvalidTagException;
class InvalidUsageAllocationsException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidUsageAllocationsException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidUsageAllocationsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidUsageAllocationsException.prototype);
    }
}
exports.InvalidUsageAllocationsException = InvalidUsageAllocationsException;
class InvalidUsageDimensionException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidUsageDimensionException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidUsageDimensionException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidUsageDimensionException.prototype);
    }
}
exports.InvalidUsageDimensionException = InvalidUsageDimensionException;
class ThrottlingException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
    }
}
exports.ThrottlingException = ThrottlingException;
class TimestampOutOfBoundsException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "TimestampOutOfBoundsException",
            $fault: "client",
            ...opts,
        });
        this.name = "TimestampOutOfBoundsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, TimestampOutOfBoundsException.prototype);
    }
}
exports.TimestampOutOfBoundsException = TimestampOutOfBoundsException;
class CustomerNotEntitledException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "CustomerNotEntitledException",
            $fault: "client",
            ...opts,
        });
        this.name = "CustomerNotEntitledException";
        this.$fault = "client";
        Object.setPrototypeOf(this, CustomerNotEntitledException.prototype);
    }
}
exports.CustomerNotEntitledException = CustomerNotEntitledException;
class DuplicateRequestException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "DuplicateRequestException",
            $fault: "client",
            ...opts,
        });
        this.name = "DuplicateRequestException";
        this.$fault = "client";
        Object.setPrototypeOf(this, DuplicateRequestException.prototype);
    }
}
exports.DuplicateRequestException = DuplicateRequestException;
class InvalidEndpointRegionException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidEndpointRegionException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidEndpointRegionException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidEndpointRegionException.prototype);
    }
}
exports.InvalidEndpointRegionException = InvalidEndpointRegionException;
class InvalidPublicKeyVersionException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidPublicKeyVersionException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidPublicKeyVersionException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidPublicKeyVersionException.prototype);
    }
}
exports.InvalidPublicKeyVersionException = InvalidPublicKeyVersionException;
class InvalidRegionException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidRegionException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidRegionException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidRegionException.prototype);
    }
}
exports.InvalidRegionException = InvalidRegionException;
class PlatformNotSupportedException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "PlatformNotSupportedException",
            $fault: "client",
            ...opts,
        });
        this.name = "PlatformNotSupportedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, PlatformNotSupportedException.prototype);
    }
}
exports.PlatformNotSupportedException = PlatformNotSupportedException;
class ExpiredTokenException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "ExpiredTokenException",
            $fault: "client",
            ...opts,
        });
        this.name = "ExpiredTokenException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ExpiredTokenException.prototype);
    }
}
exports.ExpiredTokenException = ExpiredTokenException;
class InvalidTokenException extends MarketplaceMeteringServiceException_1.MarketplaceMeteringServiceException {
    constructor(opts) {
        super({
            name: "InvalidTokenException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidTokenException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidTokenException.prototype);
    }
}
exports.InvalidTokenException = InvalidTokenException;
const TagFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.TagFilterSensitiveLog = TagFilterSensitiveLog;
const UsageAllocationFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.UsageAllocationFilterSensitiveLog = UsageAllocationFilterSensitiveLog;
const UsageRecordFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.UsageRecordFilterSensitiveLog = UsageRecordFilterSensitiveLog;
const BatchMeterUsageRequestFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.BatchMeterUsageRequestFilterSensitiveLog = BatchMeterUsageRequestFilterSensitiveLog;
const UsageRecordResultFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.UsageRecordResultFilterSensitiveLog = UsageRecordResultFilterSensitiveLog;
const BatchMeterUsageResultFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.BatchMeterUsageResultFilterSensitiveLog = BatchMeterUsageResultFilterSensitiveLog;
const MeterUsageRequestFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.MeterUsageRequestFilterSensitiveLog = MeterUsageRequestFilterSensitiveLog;
const MeterUsageResultFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.MeterUsageResultFilterSensitiveLog = MeterUsageResultFilterSensitiveLog;
const RegisterUsageRequestFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.RegisterUsageRequestFilterSensitiveLog = RegisterUsageRequestFilterSensitiveLog;
const RegisterUsageResultFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.RegisterUsageResultFilterSensitiveLog = RegisterUsageResultFilterSensitiveLog;
const ResolveCustomerRequestFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.ResolveCustomerRequestFilterSensitiveLog = ResolveCustomerRequestFilterSensitiveLog;
const ResolveCustomerResultFilterSensitiveLog = (obj) => ({
    ...obj,
});
exports.ResolveCustomerResultFilterSensitiveLog = ResolveCustomerResultFilterSensitiveLog;
