import { BatchMeterUsageCommand, } from "./commands/BatchMeterUsageCommand";
import { MeterUsageCommand } from "./commands/MeterUsageCommand";
import { RegisterUsageCommand, } from "./commands/RegisterUsageCommand";
import { ResolveCustomerCommand, } from "./commands/ResolveCustomerCommand";
import { MarketplaceMeteringClient } from "./MarketplaceMeteringClient";
export class MarketplaceMetering extends MarketplaceMeteringClient {
    batchMeterUsage(args, optionsOrCb, cb) {
        const command = new BatchMeterUsageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    meterUsage(args, optionsOrCb, cb) {
        const command = new MeterUsageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    registerUsage(args, optionsOrCb, cb) {
        const command = new RegisterUsageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    resolveCustomer(args, optionsOrCb, cb) {
        const command = new ResolveCustomerCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
}
