import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import {
  AddPermissionCommandInput,
  AddPermissionCommandOutput,
} from "../commands/AddPermissionCommand";
import {
  ChangeMessageVisibilityBatchCommandInput,
  ChangeMessageVisibilityBatchCommandOutput,
} from "../commands/ChangeMessageVisibilityBatchCommand";
import {
  ChangeMessageVisibilityCommandInput,
  ChangeMessageVisibilityCommandOutput,
} from "../commands/ChangeMessageVisibilityCommand";
import {
  CreateQueueCommandInput,
  CreateQueueCommandOutput,
} from "../commands/CreateQueueCommand";
import {
  DeleteMessageBatchCommandInput,
  DeleteMessageBatchCommandOutput,
} from "../commands/DeleteMessageBatchCommand";
import {
  DeleteMessageCommandInput,
  DeleteMessageCommandOutput,
} from "../commands/DeleteMessageCommand";
import {
  DeleteQueueCommandInput,
  DeleteQueueCommandOutput,
} from "../commands/DeleteQueueCommand";
import {
  GetQueueAttributesCommandInput,
  GetQueueAttributesCommandOutput,
} from "../commands/GetQueueAttributesCommand";
import {
  GetQueueUrlCommandInput,
  GetQueueUrlCommandOutput,
} from "../commands/GetQueueUrlCommand";
import {
  ListDeadLetterSourceQueuesCommandInput,
  ListDeadLetterSourceQueuesCommandOutput,
} from "../commands/ListDeadLetterSourceQueuesCommand";
import {
  ListQueuesCommandInput,
  ListQueuesCommandOutput,
} from "../commands/ListQueuesCommand";
import {
  ListQueueTagsCommandInput,
  ListQueueTagsCommandOutput,
} from "../commands/ListQueueTagsCommand";
import {
  PurgeQueueCommandInput,
  PurgeQueueCommandOutput,
} from "../commands/PurgeQueueCommand";
import {
  ReceiveMessageCommandInput,
  ReceiveMessageCommandOutput,
} from "../commands/ReceiveMessageCommand";
import {
  RemovePermissionCommandInput,
  RemovePermissionCommandOutput,
} from "../commands/RemovePermissionCommand";
import {
  SendMessageBatchCommandInput,
  SendMessageBatchCommandOutput,
} from "../commands/SendMessageBatchCommand";
import {
  SendMessageCommandInput,
  SendMessageCommandOutput,
} from "../commands/SendMessageCommand";
import {
  SetQueueAttributesCommandInput,
  SetQueueAttributesCommandOutput,
} from "../commands/SetQueueAttributesCommand";
import {
  TagQueueCommandInput,
  TagQueueCommandOutput,
} from "../commands/TagQueueCommand";
import {
  UntagQueueCommandInput,
  UntagQueueCommandOutput,
} from "../commands/UntagQueueCommand";
export declare const serializeAws_queryAddPermissionCommand: (
  input: AddPermissionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryChangeMessageVisibilityCommand: (
  input: ChangeMessageVisibilityCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryChangeMessageVisibilityBatchCommand: (
  input: ChangeMessageVisibilityBatchCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateQueueCommand: (
  input: CreateQueueCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteMessageCommand: (
  input: DeleteMessageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteMessageBatchCommand: (
  input: DeleteMessageBatchCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteQueueCommand: (
  input: DeleteQueueCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetQueueAttributesCommand: (
  input: GetQueueAttributesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetQueueUrlCommand: (
  input: GetQueueUrlCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListDeadLetterSourceQueuesCommand: (
  input: ListDeadLetterSourceQueuesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListQueuesCommand: (
  input: ListQueuesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListQueueTagsCommand: (
  input: ListQueueTagsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPurgeQueueCommand: (
  input: PurgeQueueCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryReceiveMessageCommand: (
  input: ReceiveMessageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryRemovePermissionCommand: (
  input: RemovePermissionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendMessageCommand: (
  input: SendMessageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendMessageBatchCommand: (
  input: SendMessageBatchCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetQueueAttributesCommand: (
  input: SetQueueAttributesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryTagQueueCommand: (
  input: TagQueueCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUntagQueueCommand: (
  input: UntagQueueCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const deserializeAws_queryAddPermissionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<AddPermissionCommandOutput>;
export declare const deserializeAws_queryChangeMessageVisibilityCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ChangeMessageVisibilityCommandOutput>;
export declare const deserializeAws_queryChangeMessageVisibilityBatchCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ChangeMessageVisibilityBatchCommandOutput>;
export declare const deserializeAws_queryCreateQueueCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateQueueCommandOutput>;
export declare const deserializeAws_queryDeleteMessageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteMessageCommandOutput>;
export declare const deserializeAws_queryDeleteMessageBatchCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteMessageBatchCommandOutput>;
export declare const deserializeAws_queryDeleteQueueCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteQueueCommandOutput>;
export declare const deserializeAws_queryGetQueueAttributesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetQueueAttributesCommandOutput>;
export declare const deserializeAws_queryGetQueueUrlCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetQueueUrlCommandOutput>;
export declare const deserializeAws_queryListDeadLetterSourceQueuesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListDeadLetterSourceQueuesCommandOutput>;
export declare const deserializeAws_queryListQueuesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListQueuesCommandOutput>;
export declare const deserializeAws_queryListQueueTagsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListQueueTagsCommandOutput>;
export declare const deserializeAws_queryPurgeQueueCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PurgeQueueCommandOutput>;
export declare const deserializeAws_queryReceiveMessageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ReceiveMessageCommandOutput>;
export declare const deserializeAws_queryRemovePermissionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RemovePermissionCommandOutput>;
export declare const deserializeAws_querySendMessageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendMessageCommandOutput>;
export declare const deserializeAws_querySendMessageBatchCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendMessageBatchCommandOutput>;
export declare const deserializeAws_querySetQueueAttributesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetQueueAttributesCommandOutput>;
export declare const deserializeAws_queryTagQueueCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagQueueCommandOutput>;
export declare const deserializeAws_queryUntagQueueCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagQueueCommandOutput>;
